/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://kenai.com/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.observation.event;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import java.util.EventObject;
import it.tidalwave.observation.Observation;
import it.tidalwave.observation.ObservationSet;

/***********************************************************************************************************************
 *
 * Represents an event notified by an {@link ObservationListener}.
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class ObservationEvent extends EventObject
  {
    @CheckForNull
    private final Observation observation;

    @CheckForNull
    private final Observation oldObservation;

    public ObservationEvent (final @Nonnull ObservationSet observationSet,
                             final @CheckForNull Observation observation,
                             final @CheckForNull Observation oldObservation)
      {
        super(observationSet);
        this.observation = observation;
        this.oldObservation = oldObservation;
      }

    @CheckForNull
    public Observation getObservation()
      {
        return observation;
      }

    @CheckForNull
    public Observation getOldObservation()
      {
        return oldObservation;
      }
  }

